Attribute VB_Name = "HTS"
Option Explicit
Rem ****************************************************************************
Rem Program constants
Rem *****************************************************************************/
Public Const FONT_TEXT = 0
Public Const FONT_H1 = 1
Public Const FONT_H2 = 2
Public Const FONT_H3 = 3
Public Const FONT_H4 = 4
Public Const FONT_H5 = 5
Public Const FONT_H6 = 6
Public Const FONT_H7 = 7
Public Const FONT_ADDRESS = 8
Public Const FONT_QUOTE = 9
Public Const FONT_MENU = 10
Public Const FONT_DIR = 11
Public Const FONT_PRE = 12
Public Const FONT_EXAMPLE = 13
Public Const FONT_VAR = 14
Public Const FONT_KBD = 15
Public Const FONT_SAMP = 16
Public Const FONT_TR = 17
Public Const FONT_HV = 18
Public Const FONT_TT = 19
Public Const FONT_TOTAL = 20

Public Const HTML_FILE = 0
Public Const HTML_BUF = 1
Public Const HTML_FILE_DLG = 2

Public Const STRONG = &H2
Public Const EMPHASIZE = &H1
Public Const CITE = &H1

Public Const PICT_UNKNOWN = 0
Public Const PICT_BMP = 1
Public Const PICT_GIF = 2
Public Const PICT_WMF = 3
Public Const PICT_TIFF = 4
Public Const PICT_JPG = 5
Public Const PICT_PNG = 6
Public Const PICT_NONE = 7

Public Const METHOD_GET = 0
Public Const METHOD_POST = 1

Public Const FTYPE_TEXT = 0
Public Const FTYPE_RADIO = 1
Public Const FTYPE_SUBMIT = 2
Public Const FTYPE_RESET = 3
Public Const FTYPE_TEXTAREA = 4
Public Const FTYPE_CHECKBOX = 5
Public Const FTYPE_HIDDEN = 6
Public Const FTYPE_PASSWORD = 7
Public Const FTYPE_IMAGE = 8
Public Const FTYPE_SELECT = 9

Public Const PARA_LIST_NONE = 0
Public Const PARA_LIST_OL = 1
Public Const PARA_LIST_UL = 2
Public Const PARA_LIST_DIR = 3
Public Const PARA_LIST_MENU = 4
Public Const PARA_LIST_DL = 5

Public Const PARA_BLOCKQUOTE = 1
Public Const PARA_ADDRESS = 2
Public Const PARA_HR = 3
Public Const PARA_PRE = 4

Public Const PARA_FORM = &H1000
Public Const PARA_BEGIN_LI = &H2000
Public Const PARA_DT = &H4000

Public Const TERM_DT = 1
Public Const TERM_DD = 2

Public Const RFLAG_NO_HDR = &H1

Public Const HFLAG_OUTPUT_DEF_FONT = &H1
Public Const HFLAG_NO_TAG_FONT = &H2
Public Const HFLAG_NO_PICT_PATH = &H4
Public Const HFLAG_NO_DIV = &H8
Public Const HFLAG_SAVE_CELL_WIDTH = &H10
Public Const HFLAG_NO_FORM_SHADING = &H20
Public Const HFLAG_NO_TOGGLE_MSG = &H40
Public Const HFLAG_FIXED_VSCROLL = &H80
Public Const HFLAG_PRESERVE_SPACES = &H100
Public Const HFLAG_SAVE_PICT_AS_WMF = &H200
Public Const HFLAG_NO_SCRIPT = &H400
Public Const HFLAG_ROUND_BULLET = &H800
Public Const HFLAG_NO_SPAN_TAG = &H1000
Public Const HFLAG_WRITE_LINK_STYLE = &H2000
Public Const HFLAG_NO_INTERNET = &H4000
Public Const HFLAG_NO_HEAD = &H8000&
Public Const HFLAG_NO_BODY = &H10000
Public Const HFLAG_NO_FONT = &H20000
Public Const HFLAG_NO_STYLE = &H40000
Public Const HFLAG_NO_LIST_MARGIN = &H80000
Public Const HFLAG_OUTPUT_DEF_FONTSIZE = &H100000
Public Const HFLAG_OUTPUT_DEF_FONTCOLOR = &H200000
Public Const HFLAG_NO_XLATE_LINK = &H400000
Public Const HFLAG_NO_HTML = &H800000
Public Const HFLAG_SAVE_CELL_WIDTH_PCT = &H8000000
Public Const HFLAG_SET_CELL_SPACE = &H10000000
Public Const HFLAG_COPY_CELL_PCT = &H20000000
Public Const HFLAG_WRITE_NUM_CHAR_CODE = &H40000000

Public Const HFLAG2_DOCTYPE            = &H1          ' write the DOCTYPE tag
Public Const HFLAG2_WRITE_OBJECT = &H4
Public Const HFLAG2_WRITE_OBJECT_PARAM = &H8
Public Const HFLAG2_SKIP_HREF          = &H10         ' ignore links in the html input
Public Const HFLAG2_OLD_HLINK          = &H20         ' support old type of hlink (hidden text/phrase pair)
Public Const HFLAG2_FLASH_SUPPORT      = &H40         ' generate html to support flash
Public Const HFLAG2_CATCH_ERRORS       = &H80         ' catch crash errors
Public Const HFLAG2_XLATE_SINGLE_QUOTE = &H100        ' write single quote as &#39;
Public Const HFLAG2_KEEP_ROW_TOGETHER  = &H200        ' keep table row together
Public Const HFLAG2_XLATE_QUOTE        = &H400        ' translate to simple quote charcter while reading 
Public Const HFLAG2_SAVE_PICT_AS_BMP   = &H800        ' save embedded pictures as bmp in when writing html
Public Const HFLAG2_WRITE_DIR          = &H1000       ' always write the dir= tag for the div tag
Public Const HFLAG2_DONT_POSITION_OBJECTS = &H2000    ' don't position objects
Public Const HFLAG2_NO_CRLF            = &H4000       ' don't output cr/lr 

Public Const HFLAG3_WORD_SUPPORT       = &H2          ' 20160704: tweak html output for Word

Public Const TAG_EMPTY = 0
Public Const TAG_CELL_QFN = 1
Public Const TAG_PICT_SIZE = 2
Public Const TAG_META = 3
Public Const TAG_PICT_USEMAP = 4
Public Const TAG_USER = 5

Public Const HALIGN_LEFT = 3
Public Const HALIGN_RIGHT = 4

Rem ***************************************************************************
Rem  Menu command contants
Rem ***************************************************************************

Public Const HTM_FIRST_COMMAND = 12098
Public Const HTM_PRINT_PREVIEW = 12098
Public Const HTM_COPY = 12099
Public Const HTM_SAVE = 12100
Public Const HTM_SAVE_AS = 12101
Public Const HTM_NEW = 12102
Public Const HTM_OPEN = 12103
Public Const HTM_EDITOR = 12104
Public Const HTM_VIEWER = 12105
Public Const HTM_SHOW_HIDDEN = 12106
Public Const HTM_SHOW_PARA_MARK = 12107
Public Const HTM_FONTS = 12108
Public Const HTM_LINK = 12109
Public Const HTM_PRINT = 12110
Public Const HTM_REFORMAT = 12111

Public Const HTM_FIRST_EDIT_COMMAND = 12112
Public Const HTM_HDR1 = 12112
Public Const HTM_HDR2 = 12113
Public Const HTM_HDR3 = 12114
Public Const HTM_HDR4 = 12115
Public Const HTM_HDR5 = 12116
Public Const HTM_HDR6 = 12117
Public Const HTM_HDR7 = 12118
Public Const HTM_BLOCKQUOTE = 12119
Public Const HTM_PRE = 12121
Public Const HTM_TT = 12122
Public Const HTM_ADDRESS = 12123
Public Const HTM_PARA_NORMAL = 12124
Public Const HTM_LEFT = 12125
Public Const HTM_RIGHT = 12126
Public Const HTM_CENTER = 12127
Public Const HTM_JUSTIFY = 12128
Public Const HTM_BOLD = 12129
Public Const HTM_ITALIC = 12130
Public Const HTM_ULINE = 12131
Public Const HTM_SUPSCR = 12132
Public Const HTM_SUBSCR = 12133
Public Const HTM_STRIKE = 12134
Public Const HTM_CHAR_NORMAL = 12135
Public Const HTM_LIST_OL = 12136
Public Const HTM_LIST_UL = 12137
Public Const HTM_LIST_LVL1 = 12138
Public Const HTM_LIST_LVL2 = 12139
Public Const HTM_LIST_LVL3 = 12140
Public Const HTM_LIST_LVL4 = 12141
Public Const HTM_LIST_LVL5 = 12142
Public Const HTM_LIST_LVL6 = 12143
Public Const HTM_LIST_LVL7 = 12144
Public Const HTM_NEW_LIST_ITEM = 12145
Public Const HTM_LIST_DT = 12146
Public Const HTM_LIST_DD = 12147
Public Const HTM_EXAMPLE = 12148
Public Const HTM_KBD = 12149
Public Const HTM_SAMP = 12150
Public Const HTM_VAR = 12151
Public Const HTM_CHAR_TYPE_NORMAL = 12152
Public Const HTM_INSERT_RULE = 12153
Public Const HTM_EDIT_RULE = 12154
Public Const HTM_INSERT_PICT = 12155
Public Const HTM_INSERT_LINK = 12156
Public Const HTM_EDIT_FORM_ID = 12157
Public Const HTM_PARA_FORM = 12158
Public Const HTM_SET_FORM_ID = 12159
Public Const HTM_INSERT_TEXT_FIELD = 12160
Public Const HTM_INSERT_BUTTON_FIELD = 12161
Public Const HTM_INSERT_IMAGE_FIELD = 12162
Public Const HTM_INSERT_SELECT_FIELD = 12163
Public Const HTM_ADD_SELECT_ITEM = 12164
Public Const HTM_DEL_SELECT_ITEM = 12165
Public Const HTM_TBL_CREATE = 12166
Public Const HTM_TBL_INSERT_ROW = 12167
Public Const HTM_TBL_APPEND_ROW = 12168
Public Const HTM_TBL_DELETE_ROW = 12169
Public Const HTM_TBL_INSERT_COL = 12170
Public Const HTM_TBL_APPEND_COL = 12171
Public Const HTM_TBL_DELETE_COL = 12172
Public Const HTM_CUT = 12173
Public Const HTM_FONT_COLOR = 12174
Public Const HTM_FONT_SIZE = 12175
Public Const HTM_EDIT_LINK = 12176
Public Const HTM_TBL_CELL_WIDTH_FLAG = 12177
Public Const HTM_PARA_SPACE = 12178
Public Const HTM_TBL_CELL_COLOR = 12179


Rem ****************************************************************************
Rem  Error contants
Rem *****************************************************************************/

Public Const HERR_MEM = 1
Public Const HERR_INIT = 2
Public Const HERR_EOF = 3
Public Const HERR_SYNTAX = 4
Public Const HERR_IO = 5
Public Const HERR_OPEN = 6
Public Const HERR_GIF = 7
Public Const HERR_LZW = 8
Public Const HERR_WMF = 9
Public Const HERR_TIFF = 10
Public Const HERR_VERSION = 11
Public Const HERR_PICT = 12
Public Const HERR_FORM = 13

Rem ****************************************************************************
Rem   Message constants
Rem *****************************************************************************/
Public Const HTS_TITLE = 3274
Public Const HTS_LINK = 3275
Public Const HTS_PICTURE = 3276
Public Const HTS_FORM = 3277
Public Const HTS_PICT_ID = 3278
Public Const HTS_BASE = 3279
Public Const HTS_LINK_URL = 3280
Public Const HTS_LINK_INFO = 3281
Public Const HTS_BK_PICT = 3282
Public Const HTS_INT_LINK = 3283
Public Const HTS_FRAME_FILE = 3284
Public Const HTS_FRAME_NAME = 3285
Public Const HTS_SAVE_PICTURE = 3286

Rem ******************************************************************************
Rem                      Viewer Function Prototype
Rem *******************************************************************************/
Public Declare Function HtsRead Lib "hts25.dll" (ByVal hwnd As Long, ByVal InputType As Long, ByVal FileName As String, ByVal hBuffer As Long, ByVal BufLen As Long, ByVal dest As String) As Long
Public Declare Function HtsInitialize Lib "hts25.dll" (ByVal hwnd As Long, ByVal hParentWnd As Long) As Long
Public Declare Function HtsLoadControl Lib "hts25.dll" () As Long
Public Declare Function HtsPositionName Lib "hts25.dll" (ByVal hwnd As Long, ByVal PosName As String) As Long
Public Declare Function HtsClearWindow Lib "hts25.dll" (ByVal hwnd As Long) As Long
Public Declare Function HtsGetFont Lib "hts25.dll" (ByVal hwnd As Long, ByVal FontId As Long, ByVal typeface As String, PointSize As float, style As Long, TextColor As Long, TextBkColor As Long) As Long
Public Declare Function HtsSetFont Lib "hts25.dll" (ByVal hwnd As Long, ByVal FontId As Long, ByVal typeface As String, ByVal PointSize As float, ByVal style As Long, ByVal TextColor As Long, ByVal TextBkColor As Long, ByVal repaint As Long) As Long
Public Declare Function HtsSetFontDlg Lib "hts25.dll" (ByVal hwnd As Long, ByVal FontId As Long) As Long
Public Declare Function HtsGetLinkInfo Lib "hts25.dll" (ByVal hwnd As Long, style As Long, TextColor As Long) As Long
Public Declare Function HtsSetLinkInfo Lib "hts25.dll" (ByVal hwnd As Long, ByVal style As Long, ByVal TextColor As Long) As Long
Public Declare Function HtsSetLinkInfoDlg Lib "hts25.dll" (ByVal hwnd As Long) As Long
Public Declare Function HtsSetPicture Lib "hts25.dll" (ByVal hwnd As Long, PictId As Long, PictType As Long, ByVal PictFile As String) As Long
Public Declare Function HtsGetFormInfo Lib "hts25.dll" (ByVal hwnd As Long, ByVal FormId As Long, ByVal Action As String, ByVal method As String) As Long
Public Declare Function HtsGetFieldData Lib "hts25.dll" (ByVal hwnd As Long, ByVal FormId As Long, ByVal FieldId As Long, ByVal FieldName As String, IntData As Long, ByVal TextData As String, ByVal TextDataLen As Long) As Long
Public Declare Function HtsLparam2String Lib "hts25.dll" (ByVal LongPtr As Long, ByVal TextPtr As String) As Long
Public Declare Function HtsString2Lparam Lib "hts25.dll" (ByVal TextPtr As String, ByVal LongPtr As Long) As Long
Public Declare Function HtsSetBkColor Lib "hts25.dll" (ByVal BkColor As Long) As Long

Public Declare Function HtsWrite Lib "hts25.dll" (ByVal hwnd As Long, ByVal OutType As Long, ByVal FileName As String, hBuf As Long, BuLen As Long, ByVal WriteSelection As Long) As Long
Public Declare Function HtsReformat Lib "hts25.dll" (ByVal hwnd As Long) As Long
Public Declare Function HtsRtfToHtml Lib "hts25.dll" (ByVal hwnd As Long, ByVal BasePictName As String) As Long
Public Declare Function HtsGetParaAttrib Lib "hts25.dll" (ByVal hwnd As Long, HdrLevel As Long, ListType As Long, ListLevel As Long, ParaAuxId As Long, MiscType As Long) As Long
Public Declare Function HtsSetHeader Lib "hts25.dll" (ByVal hwnd As Long, ByVal HdrLevel As Long, ByVal repaint As Long) As Long
Public Declare Function HtsParaNormal Lib "hts25.dll" (ByVal hwnd As Long, ByVal repaint As Long) As Long
Public Declare Function HtsSetList Lib "hts25.dll" (ByVal hwnd As Long, ByVal ListType As Long, ByVal ListLevel As Long, ByVal DtDd As Long, ByVal repaint As Long) As Long
Public Declare Function HtsSetMiscParaType Lib "hts25.dll" (ByVal hwnd As Long, ByVal MiscType As Long, ByVal repaint As Long) As Long
Public Declare Function HtsSetMiscCharType Lib "hts25.dll" (ByVal hwnd As Long, ByVal FontNo As Long, ByVal repaint As Long) As Long
Public Declare Function HtsMenuEnable Lib "hts25.dll" (ByVal hwnd As Long, ByVal CmdId As Long) As Long
Public Declare Function HtsMenuSelect Lib "hts25.dll" (ByVal hwnd As Long, ByVal CmdId As Long) As Long
Public Declare Function HtsCommand Lib "hts25.dll" (ByVal hwnd As Long, ByVal CmdId As Long) As Long
Public Declare Function HtsInsertRule Lib "hts25.dll" (ByVal hwnd As Long, ByVal repaint As Long) As Long
Public Declare Function HtsEditRule Lib "hts25.dll" (ByVal hwnd As Long, ByVal RuleWidth As Long, ByVal RuleThickness As Long, ByVal align As Long, ByVal repaint As Long) As Long
Public Declare Function HtsInsertPicture Lib "hts25.dll" (ByVal hwnd As Long, ByVal PictFile As String, ByVal align As Long, ByVal IsMap As Long, ByVal IsInput As Long, ByVal repaint As Long) As Long
Public Declare Function HtsInsertLink Lib "hts25.dll" (ByVal hwnd As Long, ByVal LinkText As String, ByVal LinkPict As String, ByVal LinkHref As String, ByVal LinkName As String, ByVal IsMap As Long, ByVal repaint As Long) As Long
Public Declare Function HtsEditFormId Lib "hts25.dll" (ByVal hwnd As Long, ByVal NewForm As Long, ByVal FormId As Long, ByVal FormMethod As Long, ByVal FormAction As String, ByVal repaint As Long) As Long
Public Declare Function HtsSetForm Lib "hts25.dll" (ByVal hwnd As Long, ByVal IsForm As Long, ByVal repaint As Long) As Long
Public Declare Function HtsSetFormId Lib "hts25.dll" (ByVal hwnd As Long, ByVal FormId As Long) As Long
Public Declare Function HtsInsertTextField Lib "hts25.dll" (ByVal hwnd As Long, ByVal FieldName As String, ByVal FieldType As Long, ByVal NumCols As Long, ByVal MaxCols As Long, ByVal NumRows As Long, ByVal InitText As String, ByVal repaint As Long) As Long
Public Declare Function HtsInsertButtonField Lib "hts25.dll" (ByVal hwnd As Long, ByVal FieldName As String, ByVal FormType As Long, ByVal CHECKED As Long, ByVal ValueString As String, ByVal repaint As Long) As Long
Public Declare Function HtsSave Lib "hts25.dll" (ByVal hwnd As Long, ByVal OutType As Long, ByVal OutFile As String, hBuf As Long, BufLen As Long) As Long
Public Declare Function HtsClose Lib "hts25.dll" (ByVal hwnd As Long, ByVal OutType As Long, ByVal OutFile As String, hBuf As Long, BufLen As Long) As Long
Public Declare Function HtsInsertSelectField Lib "hts25.dll" (ByVal hwnd As Long, ByVal FieldName As String, ByVal MultiSelect As Long, ByVal NumLines As Long, ByVal repaint As Long) As Long
Public Declare Function HtsAddSelectionItem Lib "hts25.dll" (ByVal hwnd As Long, ByVal CtlId As Long, ByVal ItemText As String, ByVal ValueString As String, ByVal ItemSelected As Long, ByVal insert As Long) As Long
Public Declare Function HtsDelSelectionItem Lib "hts25.dll" (ByVal hwnd As Long, ByVal CtlId As Long) As Long
Public Declare Function HtsNewFile Lib "hts25.dll" (ByVal hwnd As Long) As Long
Public Declare Function HtsOpenFile Lib "hts25.dll" (ByVal hwnd As Long) As Long
Public Declare Function HtsSetFontSize Lib "hts25.dll" (ByVal hwnd As Long, ByVal FontSize As Long, ByVal relative As Long, ByVal repaint As Long) As Long
Public Declare Function HtsSetNewBkColor Lib "hts25.dll" (ByVal hwnd As Long, ByVal color As Long, ByVal SetColor As Long) As Long
Public Declare Function HtsSetBkPict Lib "hts25.dll" (ByVal hwnd As Long, ByVal PictFile As String) As Long
Public Declare Function HtsRtfToHtmlEx Lib "hts25.dll" (ByVal hwnd As Long, ByVal BasePictName As String, ByVal Flags As Long) As Long
Public Declare Function HtsSetFlags Lib "hts25.dll" (ByVal hwnd As Long, ByVal SetReset As Long, ByVal Flags As Long) As Long
Public Declare Function HtsGetLinkData Lib "hts25.dll" (ByVal hwnd As Long, ByVal LinkHref As String, ByVal LinkName As String) As Long
Public Declare Function HtsUpdateLink Lib "hts25.dll" (ByVal hwnd As Long, ByVal LinkHref As String, ByVal LinkName As String, ByVal repaint As Long) As Long
Public Declare Function HtsSetNewTextColor Lib "hts25.dll" (ByVal hwnd As Long, ByVal color As Long) As Long
Public Declare Function HtsSetPictUseMap Lib "hts25.dll" (ByVal hwnd As Long, ByVal PictId As Long, ByVal UseMap As String) As Long
Public Declare Function HtsGetTagData Lib "hts25.dll" (ByVal hwnd As Long, ByVal TagType As Long, ByVal id As Long, ByVal start As Long, int1 As Long, int2 As Long, ByVal str1 As String, ByVal str2 As String) As Long
Public Declare Function HtsSetFontSizeTbl Lib "hts25.dll" (ByVal size1 As Long, ByVal size2 As Long, ByVal size3 As Long, ByVal size4 As Long, ByVal size5 As Long, ByVal size6 As Long, ByVal size7 As Long) As Long
Public Declare Function HtsGetTopWin Lib "hts25.dll" (ByVal hwnd As Long) As Long
Public Declare Function HtsSetTarget Lib "hts25.dll" (ByVal hwnd As Long, ByVal target As String) As Long
Public Declare Function HtsGetTarget Lib "hts25.dll" (ByVal hwnd As Long, ByVal target As String) As Long
Public Declare Function HtsSetFrameName Lib "hts25.dll" (ByVal hwnd As Long, ByVal Name As String) As Long
Public Declare Function HtsGetFrameName Lib "hts25.dll" (ByVal hwnd As Long, ByVal Name As String) As Long
Public Declare Function HtsSetActiveWnd Lib "hts25.dll" (ByVal hwnd As Long) As Long
Public Declare Function HtsGetActiveWnd Lib "hts25.dll" (ByVal hwnd As Long) As Long
Public Declare Function HtsModified Lib "hts25.dll" (ByVal hwnd As Long) As Long
Public Declare Function HtsSetReadOnly Lib "hts25.dll" (ByVal hwnd As Long, ByVal ReadOnly As Long) As Long
Public Declare Function HtsInViewMode Lib "hts25.dll" (ByVal hwnd As Long) As Long
Public Declare Function HtsGetLinkDataEx Lib "hts25.dll" (ByVal hwnd As Long, ByVal LinkHref As String, ByVal LinkName As String, ByVal LinkTarget As String) As Long
Public Declare Function HtsUpdateLinkEx Lib "hts25.dll" (ByVal hwnd As Long, ByVal LinkHref As String, ByVal LinkName As String, ByVal LinkTarget As String, ByVal repaint As Long) As Long
Public Declare Function HtsSetParaSpace Lib "hts25.dll" (ByVal hwnd As Long, ByVal SetSpacing As Long, ByVal repaint As Long) As Long
Public Declare Function HtsSetTableWidth Lib "hts25.dll" (ByVal hwnd As Long, ByVal Width As Long, ByVal repaint As Long) As Long
Public Declare Function HtsSetListEx Lib "hts25.dll" (ByVal hwnd As Long, ByVal ListType As Long, ByVal ListLevel As Long, ByVal DtDd As Long, ByVal NbrSymbol As Long, ByVal repaint As Long) As Long
Public Declare Function HtsSetDefaultTarget Lib "hts25.dll" (ByVal hwnd As Long, ByVal target As String) As Long
Public Declare Function HtsGetCurForm Lib "hts25.dll" (ByVal hwnd As Long, TotalForms As Long) As Long
Public Declare Function HtsSetUserTag Lib "hts25.dll" (ByVal hwnd As Long, ByVal TagId As Long, ByVal TagData As String) As Long
Public Declare Function HtsGetUserTag Lib "hts25.dll" (ByVal hwnd As Long, ByVal TagId As Long, ByVal TagData As String) As Long
Public Declare Function HtsSetDocTitle Lib "hts25.dll" (ByVal hwnd As Long, ByVal DocTitle As String) As Long
Public Declare Function HtsGetFontSize Lib "hts25.dll" (ByVal hwnd As Long, IsRelative As Long) As Long
Public Declare Function HtsGetActiveWnd2 Lib "hts25.dll" (ByVal hwnd As Long, ByVal FrameName As String) As Long
Public Declare Function HtsSetPictFileBase Lib "hts25.dll" (ByVal FileName As String) As Long
Public Declare Function HtsIsHttpFile Lib "hts25.dll" (ByVal FilePath As String) As Long
Public Declare Function HtsSetDownloadDir Lib "hts25.dll" (ByVal DirPath As String) As Long
Public Declare Function HtsIsLocalFile Lib "hts25.dll" (ByVal FilePath As String) As Long
Public Declare Function HtsInternetGet Lib "hts25.dll" (ByVal hwnd As Long, ByVal url As String, ByVal LocalName As String, ByVal GetFromCache As Long) As Long
Public Declare Function HtsGetCurPath Lib "hts25.dll" (ByVal hwnd As Long, ByVal path As String) As Long
Public Declare Function HtsSetFlags2 Lib "hts25.dll" (ByVal hwnd As Long, ByVal SetReset As Long, ByVal Flags As Long) As Long
Public Declare Function HtsSetPictFileBase2 Lib "hts25.dll" (ByVal hwnd As Long,ByVal FileName As String) As Long
Public Declare Function HtsSetDownloadDir2 Lib "hts25.dll" (ByVal hwnd As Long, ByVal DirPath As String) As Long
Public Declare Function HtsSetLicenseKey Lib "hts25.dll" (ByVal key As String) As Long
Public Declare Function HtsSetFlags3 Lib "hts25.dll" (ByVal hwnd As Long, ByVal SetReset As Long, ByVal Flags As Long) As Long

