// hts_view.h : Interface to the CHtsView Class
//
// This class is derived from the CTerView class.  Therefore, if your
// application derives a class from the CHtsView class and adds it
// to the template using CWinApp::AddDocTemplate, the framework
// will call both the constructor and the 'Create' function.
//
// Sub Systems, Inc.
// Copyright 1994.
// 159 Main Street, #8C
// Stoneham, MA 02180
/////////////////////////////////////////////////////////////////////////////

#include "hts.h"
#include "ter_view.h"

class CHtsView : public CTerView
{
       DECLARE_DYNCREATE(CHtsView)

// Construction
protected:
       CHtsView();


// Operations
public:
        virtual void SerializeRaw(CArchive &ar);
        virtual WORD EditStyles();        // return edit style constants (TER_)
        virtual LRESULT OnHtsMessage(UINT message,WPARAM wParam,LPARAM lParam);
        BOOL         HtsMenuEnable(int);  // TRUE if menu item should be enabled
        int          HtsMenuSelect(int);  // 0=unchecked, 1=checked
        void         HtsMenu(WPARAM);

// Implementation
public:
        virtual      ~CHtsView();
        virtual void DeleteContents();
        virtual void Serialize(CArchive &ar);
        virtual void ReadArchive(CArchive &ar, DWORD len);
        virtual void WriteArchive(CArchive &ar);

protected:
        BOOL         m_initialized; // TRUE when HtsInitialized called

        DWORD        GetBuffer(); // retrieve the text buffer

// Construction
protected:

// Printing support
protected:

// Generated message map functions
protected:
        //{{AFX_MSG(CHtsView)
        afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
        //}}AFX_MSG


        DECLARE_MESSAGE_MAP()
};

